/*
   FoRTH Modoki
   frtm.c ver 1.2.10
   by T. Naniwa, May. 5, 1999.
*/
#define GREETING "FoRTH Modoki Ver. 1.2.10\nMay. 5, 1999"

#include <stdio.h>

#define MAIN
#include "frtm.h"
#include "errmes.h"

#define PROMPT "frtm> "
#define PROMPT2 "dict> "

main()
{
  static char line[LINE];

  printf("%s\n", GREETING);
  init_hash();
  error_no = E_OK;
  while(1) {
    if (eval_mode == DIC1 || eval_mode == DIC2) {
      printf("%s", PROMPT2);
    }
    else 
      printf("%s", PROMPT);
    gets(line);

    eval(line);

    /* 顼ꥫХ꡼ */
    if (error_no == E_QUT) {
      break;
    }
    else if (error_no != E_OK) {
      printf("ERROR: %s\n", error_mess[error_no]);
      error_no = E_OK;
      reload_old_csp();
      if (eval_mode == DIC2) {
	/* ̤˴ */
	drop_dict();
      }
      eval_mode = RUN;
      memory = OFF;
      clear_stack();
      clear_rstack();
      clear_sstack();
    }
  }
}

eval(line)
     char *line;
{
  int i, j, len, quote;
  static char subst[LINE];

  i = 0; len = strlen(line);
  while(i < len) {
    j = 0;
    if (isspace(line[i])) {
      ++i; continue;
    }
    quote = 0;
    if (line[i] == '(') quote = 1;
    while(((! isspace(line[i])) || (quote == 1)) && line[i]) {
      if (line[i] == ')') quote = 2;
      subst[j++] = line[i++];
    }
    if (quote == 1) {
      error_no = E_UCB;
      break;
    }
    else if (quote == 2) {
      if (line[i-1] != ')') {
	error_no = E_UCB;
	break;
      }
    }
    subst[j] = 0;
    eval_word(subst);
    if (error_no != E_OK) break;
  }
}

eval_word(str)
     char *str;
{
  int val, i, sgn = 1, len;
  char *ostr;

  ostr = str;
  if (*str == '+') ++str;
  else if (*str == '-') {sgn = -1; ++str;}
  if (isdigit(*str)) {
    if (*str == '0' && str[1] == 'x') {
      /* 16 ʿɤ߹ */
      for(i = 2; str[i]; ++i) {
	if (! isxdigit(str[i])) break;
      }
      if (! str[i]) {
	sscanf(&(str[2]), "%x", &val);
	val *= sgn;
	switch(eval_mode) {
	case RUN:
	  push(val); EC;
	case SKIP:
	  if (memory == ON) {
	    cpush_int(val); EC;
	  }
	  return;
	case FGT:
	case DEF:
	case DIC1:
	  error_no = E_IVN;
	  return;
	case DIC2:
	  /* Ͽ */
	  cpush_int(val); EC;
	  return;
	}
      }
    }
    else {
      /* 10 ʿɤ߹ */
      for(i = 1; str[i]; ++i) {
	if (! isdigit(str[i])) break;
      }
      if (! str[i]) {
	sscanf(str, "%d", &val);
	val *= sgn;
	switch(eval_mode) {
	case RUN:
	  push(val); EC;
	case SKIP:
	  if (memory == ON) {
	    cpush_int(val); EC;
	  }
	  return;
	case FGT:
	case DEF:
	case DIC1:
	  error_no = E_IVN;
	  return;
	case DIC2:
	  /* Ͽ */
	  cpush_int(val); EC;
	  return;
	}
      }
    }
  }
  interp(ostr); EC;
}
